#!/usr/local/bin/perl -w
#                _____              ___ ____     _ _
#               |  ___| __ ___  ___|_ _|  _ \ __| | |__
#               | |_ | '__/ _ \/ _ \| || |_) / _` | '_ \
#               |  _|| | |  __/  __/| ||  __/ (_| | |_) |
#               |_|  |_|  \___|\___|___|_|   \__,_|_.__/
#
#	index.cgi-$Name:  $-$Revision: 1.20 $ $Date: 2002/03/10 03:11:04 $ <$Author: bapril $@freeipdb.org>
######################################################################

require 'ipdb_httpcgi.pl';

use config;
use DBI;
%config = config::config();

printHead("$config{ver}");
my $conn = DBI->connect("DBI:Pg:dbname=$config{dbname};host=$config{dbhost};port=$config{dbport}", "$config{dbuser}", "$config{dbpass}",);

my $script = get_cgi($0);
my $buffer;
my @pairs;
my $pair;
my $name;
my $value;
my $exit;

#Get Variable Space
if($ENV{'CONTENT_LENGTH'}){
	read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/,$buffer);
	foreach $pair (@pairs){
		($name,$value) = split(/=/,$pair);
		$name  =~ tr/+/ /;
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$FORM{$name} = $value;
	}
	$FORM{NULL} = "NULL";
}
unless($FORM{'ACTION'}){$FORM{'ACTION'} = "NULL";}

	
if($FORM{'ACTION'} =~ m/RECLAIM/){
	#procede to reclaim
	unless(&ClearRevDNS($conn,$FORM{'RECLAIM'})){
		unless(&ReclaimBlock($conn,$FORM{'RECLAIM'})){
			print "Reclaim Block $FORM{'RECLAIM'}\n <BR>";
		}
	}
}
if($FORM{'ACTION'} =~ /EDIT/){
	&EditForm($conn,$FORM{'EDIT'},$script);
	printTail();
	$conn->disconnect;
	exit();
}

if($FORM{'ACTION'} =~ /UPDATE/){
	&UpdateBlock($conn,$FORM{'UPDATE'},$FORM{'REGION'},$FORM{'CUSTOMER'},$FORM{'CUSTDESC'});
	print "Updated\n";
}

if($FORM{'ACTION'} =~ /SUBMIT6/){
      print "Reclaim?";
      if($FORM{'ACCEPT'}){
              print "Done!\n";
      }
      if($FORM{'DENY'}){
              &ReclaimBlock($conn,$FORM{'BLOCK'});
      }
}

if($FORM{'ACTION'} =~ /ZONEED/){
	foreach $form (keys(%FORM)){
		if($form =~ /ZONE\[(.*)\]/){
			&ToggleZone($conn,$1);
		}
	}
	if($FORM{ZONEEDIT}){
		print "Edit Zone $FORM{ZONEEDIT}\n";
	}
	$FORM{'ACTION'} = "ZONELIST";
} 

if($FORM{'ACTION'} =~ /ZONELIST/){
	print "<TABLE BORDER>\n";
	&ZoneTable($conn,$script);
	print "</TABLE>\n";
	printTail();
	$conn->disconnect;
	exit();
}

if($FORM{'ACTION'} =~ /DELETEDNS/){
	&DeleteDNSRecord($conn,$FORM{'ID'});
	print "DNS Record Deleted.";
}

if($FORM{'ACTION'} =~ /DATADUMP/){
	$exit = 0;
	if($FORM{BLOCK} =~ m/([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})\/([0-9]{1,2})/){
		$FORM{BLOCK} = $1;
		$FORM{BITS} = $2;
	} elsif ($FORM{BLOCK} =~ m/([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})/ && $FORM{BITS}){
		$FORM{BLOCK} = $1;
	} else {
		print "<TR><TD><H1>Bad IP block format.</TD></TR>\n";
		#exit = 1;
	}
	if($FORM{'REGION'} =~ /---/){
		print "<TR><TD><H1>Must Select Region </TD></TR>\n";
		$exit = 1;
	}
	if($exit){ print "</TABLE>";&printTail();$conn->disconnect;exit();} # Bail Missing some info.
	&DataDump($conn,$FORM{BLOCK},$FORM{BITS},$FORM{'REGION'});
	exit();
}

if($FORM{'ACTION'} =~ /REQ/){
print <<EOF;
<table WIDTH=100% COLS=2>
EOF

	my $exit = "";
	if($FORM{'REGION'} =~ /---/){
		print "<TR><TD><H1>Please go back and choose a REGION</TD></TR>\n";
		$exit = 1;
	}
	if($FORM{'BITS'} =~ /---/){
		print "<TR><TD><H1>Please go back and choose a Block Size</TD></TR>\n";
		$exit = 1;
	}
	if($FORM{'HOSTNAME'}){
		print "<TR><TD><H1>Can't Sethostname and request a block at the same time </TD></TR>\n";
		$exit = 1;
	}
	if($config{custname_r} && $config{custname}){
		if(!$FORM{'CUSTDESC'}){
			print "<TR><TD><H1>No $config{custname_f}</TD></TR>\n";
			$exit = 1;
		}
	}
	if($config{custnum_r} && $config{custnum}){
		if(!$FORM{'CUSTOMER'}){
			print "<TR><TD><H1>No $config{custnum_f}</TD></TR>\n";
			$exit = 1;
		}
	}
	if($config{allowRwhois}){
		if($config{requireRwhois}){
			if(!$FORM{'NETNAME'}){
				print "<TR><TD><H1>No NetName</TD></TR>\n";
				$exit = 1;
			} elsif (!$FORM{'ORG'}) {
				print "Rwhois Form";
				#&RwhoisForm($conn,,$FORM{'NETNAME'});
				$exit = 1;
			}
		}
	}
	if($exit){ print "</TABLE>";&printTail();$conn->disconnect;exit();} # Bail Missing some info.
	print "<tr>\n";
	print "<td COLSPAN=2 bgcolor=\"$config{headcolor}\" color=\"$config{headtextcolor}\" face=\"Arial,Helvetica\">";
	print "<center><b>Confirm New IP Block Assignment</b></center></font></td>\n";
	print "</tr>\n";
	print "<TR><TD>";
	my $newblock = &GetNewBlock($conn,$FORM{'REGION'},$FORM{'BITS'},$FORM{'CUSTDESC'},$FORM{'CUSTOMER'});
	print "</TD></TR><TR><TD>\n";
	print "<form METHOD=POST ACTION=$script >";
	print "<INPUT TYPE=HIDDEN NAME=ACTION VALUE=SUBMIT6>";
	print "<INPUT TYPE=HIDDEN NAME=BLOCK VALUE=$newblock>";
	print "<INPUT TYPE=SUBMIT NAME=ACCEPT VALUE=\"Confirm Allocation\">";
	print "<INPUT TYPE=SUBMIT NAME=DENY VALUE=\"Cancel Allocation\">";
	print "</TD></TR>";
	print "</TABLE></FORM>";
	printTail();
	$conn->disconnect;
	exit();
}

if($FORM{'ACTION'} =~ /SEARCH/){
	my $block = "";
	if($FORM{'BLOCK'}){
		$block = &IP2Deci($FORM{'BLOCK'});
	}
	my $region = $FORM{'REGION'};
	my $bits = $FORM{'BITS'};
	my $cust = $FORM{'CUSTOMER'};
	my $custdesc = $FORM{'CUSTDESC'};
	my $hostname = $FORM{'HOSTNAME'};
	my $id = "";
	print "<!-- REGION $region BITS $bits CUST $cust CUSTDESC $custdesc HOSTNAME $hostname-->\n";
	&AllocatedSearch_Head();
	&AllocatedSearch($conn,$script,1,$id,$block,$bits,$region,$cust,$custdesc,$hostname,1);
	print "</TABLE></FORM>";
        printTail();
	$conn->disconnect;
        exit();
}
if($FORM{'ACTION'} =~ m/RECURSE/){
	my $id1 = $FORM{'CHILDL'};
	my $id2 = $FORM{'CHILDR'};
	&AllocatedSearch_Head();
	&AllocatedSearch($conn,$script,1,$id1);
	&AllocatedSearch($conn,$script,1,$id2);
	print "</TABLE></FORM>";
	$conn->disconnect;
	exit();
}

if($FORM{'ACTION'} =~ /LISTFREE/){
	print "<TABLE BORDER>";
	print "<TR><TH>REGION</TH><TH>Block</TH><TH>Reclaim</TH><TH>ID</TH></TR>\n";
	&FreeList($conn);
	print "</TABLE></FORM>";
	printTail();
	$conn->disconnect;
	exit();
}

if($FORM{'ACTION'} =~ /SETDNS/){
	# Check for hostname and an IP address.
	$exit = 0;
	if($FORM{'HOSTNAME'} =~ m/[^A-Za-z0-9\.-]/){
                print "<TR><TD><H1>Hostname contains invalid symbols.</TD></TR>\n";
                $exit = 1;
	}
        if($exit){ print "</TABLE>";&printTail();$conn->disconnect;exit();} # Bail Missing some info.
	if($FORM{'BLOCK'} && $FORM{'HOSTNAME'} && ($FORM{'REGION'} !~ m/---/)){
		print "<TABLE BORDER>";
		$fqdn = $FORM{'HOSTNAME'};
		$fqdn =~ m/^([0-9A-Za-z-]*)\.(.*)$/;
		$hostname = $1;
		$hostname =~ s/[\/:_]/-/g;
		$hostname =~ s/[ ]//g;
		$hostname =~ s/--//g;
		$hostname =~ s/^-//g;
		$hostname =~ s/\.\././g;
		$hostname =~ s/-\././g;
		$zone = $2;
		$zone =~ s/[\/:_]/-/g;
		$zone =~ s/[ ]//g;
		$zone =~ s/--//g;
		$zone =~ s/^-//g;
		$zone =~ s/\.\././g;
		$zone =~ s/-\././g;
		$ForZone = &GetZone($conn,$zone);
		#Get Block ID and Offset.
		$BLK = ip2deci($FORM{'BLOCK'});
		@blk = &GetBlockIdNM($conn,$BLK,$FORM{'REGION'});
		$block = $blk[0];
		$index = $blk[1];

		unless($block){
			print "Block not allocated.(Can't assign DNS)";
		} else {
			#Set the reverse enrty.
			if($FORM{DNSTYPE} eq "REV" || $FORM{DNSTYPE} eq "BOTH"){
				print "Set Reverse DNS for $FORM{'BLOCK'} to $fqdn<BR>\n";
				&SetRevDNS($conn,$block,$ForZone,$index,$hostname);
				&SetRevZone($conn,$FORM{'BLOCK'},$FORM{'REGION'});
			}
			#Get/Create the Forward Block ID
			#Set the forward entry.
			if($FORM{DNSTYPE} eq "FWD" || $FORM{DNSTYPE} eq "BOTH"){
				print "Set Forward DNS for $FORM{'BLOCK'} to $fqdn<BR>\n";
				&SetFwdDNS($conn,$block,$ForZone,$index,$hostname);
			}
		}
		print "</TABLE>";
	} else {
		print "<H1><FONT COLOR=RED>No IP address ,region or hostname set</FONT></H1>\n";
		printTail();
		$conn->disconnect;
		exit();
	}
}

print <<EOF;
  <table BORDER COLS=1>
   <tr>
    <td BGCOLOR="$config{headcolor}">
     <center><h1><b>
     <font face="Arial,Helvetica" color="$config{headtextcolor}" size=+2>
     $config{ver}</font>
     </b></h1></center>
    </td>
   </tr>

   <tr>
    <td>
     <FORM ACTION=$script METHOD=POST>
     <center>
     <table BORDER WIDTH="100%" >
      <tr>
       <td>
        Block:
       </td>
       <td>
        <INPUT NAME=BLOCK SIZE=20>
       </td>
      </tr>

      <tr>
       <td>
        Subnet Mask:
       </td>

       <td>
        <select NAME="BITS">
         <option selected>--- Please Choose --
         <option value="32">/32 - 1 IP
         <option value="30">/30 - 4 IPs
         <option value="29">/29 - 8 IPs
         <option value="28">/28 - 16 IPs
         <option value="27">/27 - 32 IPs
         <option value="26">/26 - 64 IPs
         <option value="25">/25 - 128 IPs
         <option value="24">/24 - 256 IPs (1 Class C)
         <option value="23">/23 - 512 IPs (2 Class Cs)
         <option value="22">/22 - 1024 IPs (4 Class Cs)
         <option value="21">/21 - 2048 IPs (8 Class Cs)
         <option value="20">/20 - 4096 IPs (16 Class Cs)
         <option value="19">/19 - 8192 IPs (32 Class Cs)
         <option value="18">/18 - 16384 IPs (64 Class Cs)
         <option value="17">/17 - 32768 IPs (128 Class Cs)
         <option value="48">/48 --- IPv6 Allocation
         <option value="49">/49 - IPv6 Allocation
         <option value="50">/50 - IPv6 Allocation
         <option value="51">/51 - IPv6 Allocation
         <option value="52">/52 --- IPv6 Allocation
         <option value="53">/53 - IPv6 Allocation
         <option value="54">/54 - IPv6 Allocation
         <option value="55">/55 - IPv6 Allocation
         <option value="56">/56 - IPv6 Allocation
         <option value="57">/57 - IPv6 Allocation
         <option value="58">/58 - IPv6 Allocation
         <option value="59">/59 - IPv6 Allocation
         <option value="60">/60 - IPv6 Allocation
         <option value="61">/61 - IPv6 Allocation
         <option value="62">/62 - IPv6 Allocation
         <option value="63">/63 - IPv6 Allocation
         <option value="64">/64 - IPv6 Allocation
        </select>
       </td>
      </tr>

      <tr>
       <td>
        Region:
       </td>

       <td>
        <SELECT NAME=REGION>
         <OPTION> --- Please Choose ---
EOF
ListRegions($conn);
print <<EOF;
        </SELECT>
       </td>
      </tr>
EOF
if($config{custname}){
print <<EOF;
      <tr>
       <td>
        $config{custname_f}:
       </td>

       <td>
        <INPUT NAME=CUSTDESC SIZE=20>
       </td>
      </tr>
EOF
}
if($config{custnum}){
print <<EOF;
      <tr>
       <td>
        $config{custnum_f}:
       </td>
       <td>
        <INPUT NAME=CUSTOMER SIZE=20>
       </td>
      </tr>
EOF
}
if($config{allowDNS}){
print <<EOF;
      <TR>
       <TD> 
        Hostname:
       </TD>
       <TD>
        <INPUT NAME=HOSTNAME SIZE=20>  
        Set :
        <SELECT NAME=DNSTYPE>
         <OPTION VALUE=BOTH>Both forward and reverse
         <OPTION VALUE=REV>Reverse Only
         <OPTION VALUE=FWD>Forward Only
        </SELECT>
       </TD>
      </TR>
EOF
}
if($config{allowRwhois}){
print <<EOF;
      <TR>
       <TD> 
        Rhowis:
       </TD>
       <TD>
        Net-Name:<INPUT NAME=NETNAME>
       </TD>
      </TR>
EOF
}

print <<EOF;
      <tr>
       <td>
        Action:
       </td>
       <td>
        <SELECT NAME=ACTION>
         <OPTION> --- Please Choose ---
         <OPTION VALUE=REQ>Request Assignment
         <OPTION VALUE=SEARCH>Search for block in database.
         <OPTION VALUE=LISTFREE>List free blocks.
EOF

if($config{allowDNS}){
print <<EOF;
         <OPTION VALUE=SETDNS>Set DNS Mapping for address.
         <OPTION VALUE=ZONELIST>List DNS Zones.
EOF
}
if($config{allowRwhois}){
print <<EOF;
         <OPTION VALUE=SETRWHOIS>Set Rwhois record.
EOF
}

if($config{allowDump}){
	print <<EOF;
	<OPTION VALUE=DATADUMP>Block Dump.
EOF
}

print <<EOF;
        </SELECT>
       </td>
      </tr>
      <TR>
       <TD COLSPAN=2>
        <CENTER><INPUT TYPE=SUBMIT VALUE="Submit Request"><INPUT TYPE=RESET>
        </CENTER></FORM>
       </TD>
      </TR>
     </table></center>
    </td>
   </tr>
  </table></center>
EOF
&printTail;
$conn->disconnect;
