#!/usr/local/bin/perl -w
#                _____              ___ ____     _ _
#               |  ___| __ ___  ___|_ _|  _ \ __| | |__
#               | |_ | '__/ _ \/ _ \| || |_) / _` | '_ \
#               |  _|| | |  __/  __/| ||  __/ (_| | |_) |
#               |_|  |_|  \___|\___|___|_|   \__,_|_.__/
#
#	admin.cgi-$Name:  $-$Revision: 1.13 $ $Date: 2002/03/28 04:21:12 $ <$Author: bapril $@freeipdb.org>
######################################################################

require 'ipdb_httpcgi.pl';
use config;
%config = config::config();

printHead("$config{ver}");

print <<EOF;
<center><table BORDER COLS=2>
<tr>
<td BGCOLOR="$config{headcolor}" COLSPAN=2>
<center>
<h1>
<b><font face="Arial,Helvetica" color="$config{headtextcolor}" SIZE=+2>
$config{ver}</font>
</font></b></h1></center>
</td>
</tr>
EOF

use DBI;
my $script = get_cgi($0);
my $conn = DBI->connect("DBI:Pg:dbname=$config{dbname};host=$config{dbhost};port=$config{dbport}", "$config{dbuser}", "$config{dbpass}",);
my $buffer;
my @pairs;
my $pair;
my $name;
my $value;
my %FORM;
my $exit;

#Get Variable Space
read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
@pairs = split(/&/,$buffer);
foreach $pair (@pairs){
	($name,$value) = split(/=/,$pair);
	$name  =~ tr/+/ /;
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$FORM{$name} = $value;
}
$FORM{NULL} = "NULL";

if($FORM{'FORM'} =~ /IMPORT/){
	print "Importing IP Blocks<BR>\n";
	my @lines = split('\n',$FORM{'DATA'});
	my $i = 0;
	while($lines[$i]){
		my @line = split(':',$lines[$i]);	
		my $ver = &VersionFromRegion($conn,$FORM{'REGION'});
		my $added = &SetBlockP($conn,$line[0],$FORM{'REGION'},$line[1],$line[2],$line[3],$ver);
		if($added){
			print "Line successfully added Block: $added\n<BR>\n";
		} else {
			print "Line Failed: $lines[$i]<BR>\n";
		}
		$i++;
	}
}

if($FORM{'FORM'} =~ /RECLAIM/){
	#procede to reclaim
	&ReclaimBlock($conn,$FORM{'RECLAIM'});
	print "Reclaim Block $FORM{'RECLAIM'}\n <BR>";
}
if($FORM{'FORM'} =~ /EDIT/){
	&EditForm($conn,$FORM{'EDIT'},$script);
	printTail();
	$conn->disconnect;
	exit();
}

if($FORM{'FORM'} =~ /UPDATE/){
	if($exit){
		printTail();
		$conn->disconnect;
		exit();
	}
	&UpdateBlock($conn,$FORM{'UPDATE'},$FORM{'REGION'},$FORM{'CUSTOMER'},$FORM{'CUSTDESC'});
	print "Updated\n";
}

if($FORM{'FORM'} =~ /SUBMIT4/){
print <<EOF;

<tr>
<td COLSPAN=2 bgcolor="$config{headcolor}" color="$config{headtextcolor}" SIZE=+2 face="Arial,Helvetica"><center><b>Confirm New IP Block 
Assignment</b></center></font></td>
</tr>
EOF
	my $exit = "";
	if($FORM{'REGION'} =~ /---/){
		print "<TR><TD><H1>Please go back and choose a REGION</TD></TR>\n";
		$exit = 1;
	}
	if($FORM{'BITS'} =~ /---/){
		print "<TR><TD><H1>Please go back and choose a Block Size</TD></TR>\n";
		$exit = 1;
	}
	if($exit){ 
		print "</TABLE>";
		&printTail();
		$conn->disconnect;
		exit();
	} # Bail Missing some info.
	print "<TR><TD COLSPAN=2>";
	$ver = &VersionFromRegion($conn,$FORM{'REGION'});
	my $id = SetBlockP($conn,$FORM{'BLOCK'},$FORM{'REGION'},$FORM{'BITS'},$FORM{'CUSTDESC'},$FORM{'CUSTOMER'},$ver);
	&SetRegion($conn,$id,$FORM{'REGION'});
	if($id){
		print "<H1>Success Your block id $id</H1>\n";
	} else {
		print "<H1>For some reason this request failed</H1>\n";
	}
	print "</TD></TR>";

}
if($FORM{'FORM'} =~ /SUBMIT5/){
	if($FORM{'REGION'} =~ /---/){
		print "<TR><TD><H1>Please go back and set a Region</TD></TR>\n";
		$exit = 1;	
	}
	unless($FORM{'BLOCK'} =~ /[\dA-Fa-f\:\.]+/){
		print "<TR><TD><H1>Please go back and set a Block</TD></TR>\n";
		my $BLK = IP2Deci($FORM{'BLOCK'});
		print "$FORM{'BLOCK'}   $BLK\n";
		$exit = 1;	
	}
	unless($FORM{'BITS'}){
		print "<TR><TD><H1>Please go back and set Bits</TD></TR>\n";
		$exit = 1;	
	}
	if($exit){ 
		print "</TABLE>";
		&printTail();
		$conn->disconnect;
		exit();
	} # Bail Missing some info.
	#my $blk_bits = ip2deci($FORM{'BLOCK'});
	&AddBlock($conn,$FORM{'BLOCK'},$FORM{'BITS'},$FORM{'REGION'},$FORM{'PRIORITY'});
}

if($FORM{'FORM'} =~ /SUBMIT7/){
	if($FORM{'RANAME'}){
		AddRA($conn,$FORM{'RANAME'});
	} else {
		print "<H1>If you wanted to add an RA why didn\'t you give it a name?</H1>\n";
	}
}
if($FORM{'FORM'} =~ /SUBMIT8/){
	if($FORM{'RA'}){
		if($FORM{'REGIONNAME'}){
			AddRegion($conn,$FORM{'RA'},$FORM{'REGIONNAME'},$FORM{'v6'});
		} else {
			print "<H1>You asked me to add a region and didn\'t name it?</H1>\n";
		}
	} else {
		print "<H1>You want to add a region and didn\'t choose an RA?</H1>\n";
	}

}

if($FORM{'FORM'} =~ /SUBMIT9/){
	$bblock = &ip2deci($FORM{'BLOCK'});
	$id = &GetBlockId($conn,$bblock,$FORM{'BITS'},$FORM{'REGION_START'});
	unless($id){
		print "The block does not exist in the starting region";
		$conn->disconnect;
		exit();
	}
	$ver = &Version($conn,$id);
	my $added = &SetBlockP($conn,$FORM{'BLOCK'},$FORM{'REGION_END'},$FORM{'BITS'},1,1,$ver);
	if($added){
		print "A parent of that block exists.<BR>\n";
		&reclaim($conn,$added);
	} else {
		$newblock = &CheckBlockFree($conn,$bblock,$FORM{'BITS'},$FORM{'REGION_START'});
		if($newblock == -1){
			print "The block's parent must exist.\n";
			$conn->disconnect;
			exit();
		}
		if($newblock == 0){
			$ver = &VersionFromRegion($conn,$FORM{'REGION_START'});
			$newblock = &MakeParent($conn,$bblock,$FORM{'BITS'},$FORM{'REGION_START'},$bblock,$ver);
			unless($newblock){print "Could not find parent block"; }
		}
		if(&SetRegion($conn,$newblock,$FORM{'REGION_END'})){
			print "Success  $newblock!\n";
		} else {
			print "There was an error\n";
		}
	}
}

if($FORM{'FORM'} =~ /SUBMITA/){
        $bblock = &ip2deci($FORM{'BLOCK'});
        $id = &CheckBlockFree($conn,$bblock,$FORM{'BITS'},$FORM{'REGION'});
	if($id == -1){
		print "Block's parent must exist\n";
		return(0);
	} elsif ($id == 0){
		print "Block's must exist\n";
		return(0);
	}
	&SetReclaim($conn,$id,1);
}

print <<EOF;
<tr>
<td bgcolor=#000000><font color=#FFFFFF>Add a specified Block:</font></td>
<td bgcolor=#000000><font color=#FFFFFF>Add Allocations.</font></td>
</tr>
<TR><FORM ACTION=$script METHOD=POST>
<INPUT TYPE=HIDDEN NAME=FORM VALUE=SUBMIT4>
<TD>Block:<input TYPE=TEXT NAME="BLOCK" SIZE=18> Region:<SELECT NAME="REGION">
<option selected>--- Please Choose ---
EOF
ListRegions($conn);
print " </SELECT><BR>";
print <<EOF;
Bits: <INPUT NAME=BITS SIZE=4><BR>
EOF
if($config{custname}){
print "$config{custname_f}: <INPUT NAME=CUSTDESC><BR>";
} 
if($config{custnum}){
print "$config{custnum_f}:<INPUT NAME=CUSTOMER><BR>";
}
print <<EOF;
<input TYPE=SUBMIT VALUE=Add Block></FORM>
<H2><FONT COLOR=RED>WARNING: This function will override the 10 day holding period</FONT></H2>
</TD><TD>
<FORM ACTION=$script METHOD=POST>
<INPUT TYPE=HIDDEN NAME=FORM VALUE=SUBMIT5>
Block(10.0.0.0 or 0000:0000:0000:0000:0000:0000:0000:0000)<INPUT NAME=BLOCK><BR>
Bits(0-32 or 0-128)<INPUT NAME=BITS><BR>
Region <SELECT NAME=REGION><OPTION SELECTED>--- Please Choose ---
EOF
ListRegions($conn);
print <<EOF;
</SELECT><BR>
Priority: <INPUT NAME=PRIORITY><BR>
<INPUT TYPE=SUBMIT VALUE=Add Block>
</TD></TR></FORM>
<tr>
<td bgcolor=#000000><font color=#FFFFFF>Add a RA:</FONT></TD>
<td bgcolor=#000000><font color=#FFFFFF>Add a Region</FONT></TD>
</TR>
<TR><FORM ACTION=$script METHOD=POST>
<INPUT TYPE=HIDDEN NAME=FORM VALUE=SUBMIT7>
<TD>
Name:<INPUT NAME=RANAME><BR>
<INPUT TYPE=SUBMIT VALUE="Add RA">
</TD></FORM>
<FORM ACTION=$script METHOD=POST>
<INPUT TYPE=HIDDEN NAME=FORM VALUE=SUBMIT8>
<TD>
RA:<SELECT NAME=RA><OPTION>--- Please Choose ---
EOF
ListRA($conn);
print <<EOF;
</SELECT><BR>
Name:<INPUT NAME=REGIONNAME><BR>
IPv6 <INPUT TYPE=CHECKBOX NAME=v6><BR>
<INPUT TYPE=SUBMIT VALUE="Add Region">
</TD></FORM>
</TR>
<tr>
<td bgcolor=#000000><font color=#FFFFFF>Put a block in a region(Block must exist):</FONT></TD>
<td bgcolor=#000000><font color=#FFFFFF>Set the Reclaim flag on a block(and all children):</FONT></TD>
</TR>
</TR>
<TR><FORM ACTION=$script METHOD=POST>
<INPUT TYPE=HIDDEN NAME=FORM VALUE=SUBMIT9>
<TD>
Block:<INPUT NAME=BLOCK><BR>
Bits:<INPUT NAME=BITS><BR>
Starting Region:<SELECT NAME=REGION_START>
<OPTION SELECTED>--- Please Choose ---
EOF
ListRegions($conn);
print <<EOF;
</SELECT><BR>
Ending Region:<SELECT NAME=REGION_END>
<OPTION SELECTED>--- Please Choose ---
EOF
ListRegions($conn);
print <<EOF;
</SELECT><BR>
<INPUT TYPE=SUBMIT VALUE="Move Block">
</TD></FORM>
<FORM ACTION=$script METHOD=POST>
<INPUT TYPE=HIDDEN NAME=FORM VALUE=SUBMITA>
<TD>
Block:<INPUT NAME=BLOCK><BR>
Bits:<INPUT NAME=BITS><BR>
Region:(for confirmation)<SELECT NAME=REGION>
<OPTION SELECTED>--- Please Choose ---
EOF
ListRegions($conn);
print <<EOF;
</SELECT><BR>
<INPUT TYPE=SUBMIT VALUE="Set Reclaim">
<H1><FONT COLOR=RED>WARNING!!! WARNING!!! DANGER Will Robinson!</FONT></H1>
<H2>This will prevent any blocks that are children of this one from being allocated.</H2>
</TD></FORM>
</TR>
<tr>
<td bgcolor=#000000 COLSPAN=2><font color=#FFFFFF>Import Blocks:</FONT></TD>
</TR>
<TR><FORM ACTION=$script METHOD=POST>
<INPUT TYPE=HIDDEN NAME=FORM VALUE=IMPORT>
<TD COLSPAN=2>
Region:<SELECT NAME=REGION>
<OPTION SELECTED>--- Please Choose ---
EOF
ListRegions($conn);
print <<EOF;
</SELECT><BR>
Blocks:<BR>
<TEXTAREA COLS=100 ROWS=20 NAME=DATA></TEXTAREA><br>
Format:<br>
<I>ip address:netmask
EOF

if($config{custname}){
	print ":$config{custname_f}";
}
if($config{custnum}){
	print ":$config{custnum_f}";
}


print <<EOF;
</I><br>
Parent is required to exist and be availiable.
<INPUT TYPE=SUBMIT VALUE="Import Blocks">
</TD></FORM>
</TR>
</table>
EOF

&printTail;
$conn->disconnect;
